D_PANEL_LEFT EQU 100
D_PANEL_TOP EQU 50
D_PANEL_WIDTH EQU 405
D_PANEL_HEIGHT EQU 340
D_KEY_LEFT EQU 144
D_KEY_TOP EQU 148
D_KEY_WIDTH EQU 54
D_KEY_HEIGHT EQU 38
D_KEY_SPACE EQU 10
D_KEY_TEXT_LEFT EQU 20
D_KEY_TEXT_TOP EQU 10
D_KEY_TEXT_SPACE_W EQU 8
D_KEY_TEXT_SPACE_H EQU 3
D_SCREEN_LEFT EQU 144
D_SCREEN_TOP EQU 100
D_SCREEN_WIDTH EQU 311
D_SCREEN_HEIGHT EQU 32
D_ANS_TEXT_LEFT EQU 20
D_ANS_TEXT_TOP EQU 8
D_CLOSE_BUTTON_L EQU D_PANEL_LEFT+D_PANEL_WIDTH-19
D_CLOSE_BUTTON_T EQU D_PANEL_TOP+4
D_CLOSE_BUTTON_R EQU D_PANEL_LEFT+D_PANEL_WIDTH-3
D_CLOSE_BUTTON_B EQU D_PANEL_TOP+18

DrawCloseButton MACRO isdown
	LOCAL L1,L2,color1,color2
	PUSHREG SI,AX,BX,CX
	JMP L1
		color1 DB ?
		color2 DB ?
	L1:
	IFB <isdown>
		MOV color1,WHITE
		MOV color2,BLACK
	ELSE
		MOV color1,BLACK
		MOV color2,WHITE
	ENDIF
	rectangle D_CLOSE_BUTTON_L-1,D_CLOSE_BUTTON_T-1,D_CLOSE_BUTTON_R-1,D_CLOSE_BUTTON_B-1,color1
	rectangle D_CLOSE_BUTTON_L+1,D_CLOSE_BUTTON_T+1,D_CLOSE_BUTTON_R+1,D_CLOSE_BUTTON_B+1,color2
	rectangle D_CLOSE_BUTTON_L,D_CLOSE_BUTTON_T,D_CLOSE_BUTTON_R,D_CLOSE_BUTTON_B,LIGHTGRAY,LIGHTGRAY
	
	MOV SI,D_CLOSE_BUTTON_R-D_CLOSE_BUTTON_L-9
	MOV AX,D_CLOSE_BUTTON_L+5
	MOV BX,D_CLOSE_BUTTON_T+4
	MOV CX,D_CLOSE_BUTTON_B-4
	L2:
		putpixel AX,BX,BLACK
		putpixel AX,CX,BLACK
		INC AX
		INC BX
		DEC CX
		DEC SI
		JNZ L2
	POPREG SI,AX,BX,CX
ENDM

DrawPanel MACRO
	LOCAL L,T,R,B
	L EQU D_PANEL_LEFT
	T EQU D_PANEL_TOP
	R EQU D_PANEL_LEFT+D_PANEL_WIDTH
	B EQU D_PANEL_TOP+D_PANEL_HEIGHT
	rectangle L-1,T-1,R-1,B-1,WHITE
	rectangle L,T,R,B,LIGHTGRAY,LIGHTGRAY
	rectangle L+1,T+1,R-1,T+21,LIGHTBLUE,LIGHTBLUE
	DrawCloseButton
ENDM

DrawButton MACRO which,isdown
	LOCAL t_which,l,t,r,b,i,j,xt,yt,color1,color2,keyWord,L1,L2,L3,L1_1,L1_11,LEnd,tc
	PUSHREG AX,BX,CX,DX,SI
		mouse_beforedraw
		JMP L1
		IRP var,<t_which>
			var DB ?
		ENDM
		l DW ?
		t DW ?
		r DW ?
		b DW ?
		i DB ?
		j DB ?
		xt DB ?
		yt DB ?
		tc DB ?
		color1 DB ?
		color2 DB ?
		keyWord DB ' M+',89H, ' MR',89H,' MS',89H,' MC',89H,' C ',8BH
				DB ' 7 ',8EH,' 8 ',8EH,' 9 ',8EH,' / ',8DH,' CE',8BH
				DB ' 4 ',8EH,' 5 ',8EH,' 6 ',8EH,' * ',8DH,' ( ',8DH
				DB ' 1 ',8EH,' 2 ',8EH,' 3 ',8EH,' - ',8DH,' ) ',8DH
				DB ' 0 ',8EH,'+/-',8EH,' . ',8EH,' + ',8DH,' = ',8DH
	L1:	CMP which,25
		JZ L1_11
		JMP L1_1
		L1_11:
		IFNB <isdown>
			DrawCloseButton 1
		ELSE
			DrawCloseButton
		ENDIF
		JMP LEnd
		
	L1_1:
		XMOVB t_which,which
		MOV AH,0				;i=t_which/5; j=t_which%5
		MOV AL,t_which
		MOV BL,5
		DIV BL
		MOV i,AL
		MOV j,AH
		MOV AX,D_KEY_WIDTH		;l=D_KEY_LEFT+j*(D_KEY_WIDTH+D_KEY_SPACE)
		ADD AX,D_KEY_SPACE
		MUL j
		ADD AX,D_KEY_LEFT
		MOV l,AX
		ADD AX,D_KEY_WIDTH		;r=l+D_KEY_WIDTH
		MOV r,AX
		MOV AX,D_KEY_HEIGHT		;t=D_KEY_TOP+i*(D_KEY_HEIGHT+D_KEY_SPACE)
		ADD AX,D_KEY_SPACE
		MUL i
		ADD AX,D_KEY_TOP
		MOV t,AX
		ADD AX,D_KEY_HEIGHT		;b=t+D_KEY_HEIGHT
		MOV b,AX
		
		IFNB <isdown>
			MOV color1,BLACK
			MOV color2,WHITE
		ELSE
			MOV color1,WHITE
			MOV color2,BLACK
		ENDIF
		
		MOV AX,l
		MOV BX,t
		MOV CX,r
		MOV DX,b
		DEC AX
		DEC BX
		DEC CX
		DEC DX
		rectangle AX,BX,CX,DX,color1
		ADD AX,2
		ADD BX,2
		ADD CX,2
		ADD DX,2
		rectangle AX,BX,CX,DX,color2
		DEC AX
		DEC BX
		DEC CX
		DEC DX
		rectangle AX,BX,CX,DX,LIGHTGRAY,LIGHTGRAY
		
		MOV AX,D_KEY_TEXT_SPACE_H	;xt=D_KEY_TEXT_TOP+i*D_KEY_TEXT_SPACE_H
		MUL i
		ADD AX,D_KEY_TEXT_TOP
		MOV xt,AL
		MOV AX,D_KEY_TEXT_SPACE_W	;yt=D_KEY_TEXT_LEFT+j*D_KEY_TEXT_SPACE_W
		MUL j
		ADD AX,D_KEY_TEXT_LEFT
		MOV yt,AL
			
		MOV AL,t_which
		MOV DL,4
		MUL DL
		MOV AH,0
		MOV SI,AX
		MOV DH,3
		MOV DL,yt
		MOV BL,keyWord[SI+3]
		MOV tc,BL
	L2:	gotoxy xt,DL
		MOV AH,09H
		MOV BH,0
		MOV BL,tc
		MOV CX,1
		MOV AL,keyWord[SI]
		INT 10H
		INC SI
		INC DL
		DEC DH
		JNZ L2
	LEnd:
	mouse_afterdraw
	POPREG AX,BX,CX,DX,SI
ENDM

DrawScreen MACRO
	LOCAL L,T,R,B,L1
	mouse_beforedraw
	PUSHREG AX,BX,CX,DX,SI
	L EQU D_SCREEN_LEFT
	T EQU D_SCREEN_TOP
	R EQU D_SCREEN_LEFT+D_SCREEN_WIDTH
	B EQU D_SCREEN_TOP+D_SCREEN_HEIGHT
	linex L-1,R+2,T-1,BLACK
	liney T-1,B+2,L-1,BLACK
	linex L-1,R+2,B+2,WHITE
	liney T-1,B+2,R+2,WHITE
	rectangle L,T,R,B,WHITE,WHITE
	
	MOV SI,0
L1:
	MOV AX,25
	ADD AX,SI
	gotoxy 7,AL
	MOV AL,ScreenText[SI]
	MOV AH,09H
	MOV BH,0
	MOV BL,8FH
	MOV CX,1
	INT 10H
	INC SI
	CMP SI,ScreenN
	JNZ L1
	mouse_afterdraw
	POPREG AX,BX,CX,DX,SI
ENDM

DrawAll MACRO
	LOCAL L1,L2,L3
	PUSHREG CX
		DrawPanel
		MOV CX,0
	L1:	DrawButton CL
		INC CX
		CMP CX,25
		JNZ L2
		JMP L3
	L2:	JMP L1
	L3:
	POPREG CX
ENDM
